var Command = require('jasmine/lib/command.js');
var Jasmine = require('jasmine/lib/jasmine.js');

require('babel/register');

module.exports = function (cwd, args) {
  var cb = arguments[arguments.length - 1];

  if (!Array.isArray(args)) {
    args = Array.isArray(cwd) ? cwd : [];
  }

  if ('string' !== typeof cwd) {
    cwd = process.cwd();
  }


  var jasmine = new Jasmine({ projectBaseDir: cwd });

  if ('function' === typeof cb) {
    jasmine.addReporter(new CallbackReporter(cb));
  }

  return new Command(cwd).run(jasmine, args);
};

function CallbackReporter(cb) {
  var hasFailed = false;
  this.specDone = function (result) {
    if (result.status === 'failed') {
      hasFailed = true;
    }
  };

  this.jasmineDone = function () {
    cb(hasFailed ? new Error() : undefined);
  };
};
